(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('apstorydnn-navigation-angular', ['exports', '@angular/core'], factory) :
    (factory((global['apstorydnn-navigation-angular'] = {}),global.ng.core));
}(this, (function (exports,i0) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ApstorydnnNavigationService = /** @class */ (function () {
        function ApstorydnnNavigationService(componentFactory) {
            this.componentFactory = componentFactory;
            this.navStack = [];
            this.params = [];
        }
        /**
         * @private
         * @param {?} type
         * @return {?}
         */
        ApstorydnnNavigationService.prototype.setComponent = /**
         * @private
         * @param {?} type
         * @return {?}
         */
            function (type) {
                if (this.componentRef) {
                    this.componentRef.destroy();
                }
                /** @type {?} */
                var factory = this.componentFactory.resolveComponentFactory(type);
                this.componentRef = this.componentHolder.createComponent(factory);
            };
        /**
         * @param {?} navHolder
         * @return {?}
         */
        ApstorydnnNavigationService.prototype.setup = /**
         * @param {?} navHolder
         * @return {?}
         */
            function (navHolder) {
                this.componentHolder = navHolder;
            };
        /**
         * @param {?} key
         * @param {?} value
         * @return {?}
         */
        ApstorydnnNavigationService.prototype.setParam = /**
         * @param {?} key
         * @param {?} value
         * @return {?}
         */
            function (key, value) {
                this.params[key] = value;
            };
        /**
         * @param {?} key
         * @return {?}
         */
        ApstorydnnNavigationService.prototype.getParam = /**
         * @param {?} key
         * @return {?}
         */
            function (key) {
                return this.params[key];
            };
        /**
         * @param {?} page
         * @return {?}
         */
        ApstorydnnNavigationService.prototype.push = /**
         * @param {?} page
         * @return {?}
         */
            function (page) {
                if (this.prevPage) {
                    this.navStack.push(this.prevPage);
                }
                this.setComponent(page);
                this.prevPage = page;
            };
        /**
         * @return {?}
         */
        ApstorydnnNavigationService.prototype.canPop = /**
         * @return {?}
         */
            function () {
                return this.navStack.length > 0;
            };
        /**
         * @return {?}
         */
        ApstorydnnNavigationService.prototype.pop = /**
         * @return {?}
         */
            function () {
                if (this.canPop()) {
                    this.prevPage = this.navStack.pop();
                    this.setComponent(this.prevPage);
                }
            };
        ApstorydnnNavigationService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        ApstorydnnNavigationService.ctorParameters = function () {
            return [
                { type: i0.ComponentFactoryResolver }
            ];
        };
        /** @nocollapse */ ApstorydnnNavigationService.ngInjectableDef = i0.defineInjectable({ factory: function ApstorydnnNavigationService_Factory() { return new ApstorydnnNavigationService(i0.inject(i0.ComponentFactoryResolver)); }, token: ApstorydnnNavigationService, providedIn: "root" });
        return ApstorydnnNavigationService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.ApstorydnnNavigationService = ApstorydnnNavigationService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=apstorydnn-navigation-angular.umd.js.map