import { Injectable, ComponentFactoryResolver, defineInjectable, inject } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ApstorydnnNavigationService {
    /**
     * @param {?} componentFactory
     */
    constructor(componentFactory) {
        this.componentFactory = componentFactory;
        this.navStack = [];
        this.params = [];
    }
    /**
     * @private
     * @param {?} type
     * @return {?}
     */
    setComponent(type) {
        if (this.componentRef) {
            this.componentRef.destroy();
        }
        /** @type {?} */
        const factory = this.componentFactory.resolveComponentFactory(type);
        this.componentRef = this.componentHolder.createComponent(factory);
    }
    /**
     * @param {?} navHolder
     * @return {?}
     */
    setup(navHolder) {
        this.componentHolder = navHolder;
    }
    /**
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    setParam(key, value) {
        this.params[key] = value;
    }
    /**
     * @param {?} key
     * @return {?}
     */
    getParam(key) {
        return this.params[key];
    }
    /**
     * @param {?} page
     * @return {?}
     */
    push(page) {
        if (this.prevPage) {
            this.navStack.push(this.prevPage);
        }
        this.setComponent(page);
        this.prevPage = page;
    }
    /**
     * @return {?}
     */
    canPop() {
        return this.navStack.length > 0;
    }
    /**
     * @return {?}
     */
    pop() {
        if (this.canPop()) {
            this.prevPage = this.navStack.pop();
            this.setComponent(this.prevPage);
        }
    }
}
ApstorydnnNavigationService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
ApstorydnnNavigationService.ctorParameters = () => [
    { type: ComponentFactoryResolver }
];
/** @nocollapse */ ApstorydnnNavigationService.ngInjectableDef = defineInjectable({ factory: function ApstorydnnNavigationService_Factory() { return new ApstorydnnNavigationService(inject(ComponentFactoryResolver)); }, token: ApstorydnnNavigationService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { ApstorydnnNavigationService };

//# sourceMappingURL=apstorydnn-navigation-angular.js.map